#include "openFile.h"

#include <qdir.h>
#include <qstringlist.h>
#include <qfileinfo.h>

#include <qpe/global.h>

OpenFile::OpenFile(int selectMode_, QString dataLocation_, bool showNewFile_, QWidget* parent, const char* name, bool modal, WFlags fl) :
        OpenFileBase(parent, name, modal, fl)
{
    showNewFile = showNewFile_;

	QString tmp = "";
	if(dataLocation_ == ""){
		tmp = Global::applicationFileName("iqnotes", "");
	}else{
		tmp = dataLocation_;
	}
    
    QDir d(tmp);
    if(selectMode_ == 3)
	    d.setNameFilter("*.txt");
	else
	    d.setNameFilter("*.xml *.rijn");
    QStringList fileNames = d.entryList();

	if(selectMode_ == 1)
	    setCaption( tr( "ǡ򳫤" ) );
	else if(selectMode_ == 2)
	    setCaption( tr( "ǡ" ) );
	else if(selectMode_ == 3)
	    setCaption( tr( "ǡ򥤥ݡȤ" ) );

    if (showNewFile)
        FileList->insertItem(tr("ǡ"));

    for(QStringList::Iterator it = fileNames.begin(); it != fileNames.end(); ++it )
    {
        QString fName = *it;
        QFileInfo fInfo(fName);

        QString fListName = fName.left(fName.length() - fInfo.extension().length() - 1);
        if (fListName == "#init_file#")
            continue;
        if (fListName == "init_file")
            continue;
        FileList->insertItem(fListName);
    }

    if (FileList->count())
        FileList->setCurrentItem(0);
}

void OpenFile::accept()
{
    int index = getSelectedIndex();
    if (showNewFile && !index)
        index = -2;
    emit fileSelected(index, getSelectedFileName());
    
    OpenFileBase::accept();
}
